<table
  mat-table
  [dataSource]="dataSource"
  matSort
  class="components-table border-grey-300"
  aria-label="Selected-category components table"
>
  <ng-container matColumnDef="type">
    <th
      mat-header-cell
      *matHeaderCellDef
      mat-sort-header
      sortActionDescription="Sort by component name"
    >
      Component name
    </th>
    <td mat-cell *matCellDef="let comp">
      {{
        (
          (comp.customImage ? getCustomComponentName(comp) : comp.type)
          | titlecaseNodeName
        )
          ?.replace("FE", "Front-end")
          ?.replace("BE", "Back-end")
      }}
    </td>
  </ng-container>

  <ng-container matColumnDef="author">
    <th
      mat-header-cell
      *matHeaderCellDef
      mat-sort-header
      sortActionDescription="Sort by parameters"
    >
      Author
    </th>
    <td mat-cell *matCellDef="let comp">
      <a [href]="simplUrl" target="_blank" rel="noopener noreferrer">
        {{ comp.customImage ? "My Tenant" : "Simpl Open" }}
      </a>
    </td>
  </ng-container>

  <ng-container matColumnDef="moreInfo">
    <th mat-header-cell *matHeaderCellDef></th>
    <td mat-cell *matCellDef="let comp">
      <button
        class="simplut-comp-more-info-btn"
        mat-stroked-button
        color="primary"
        (click)="showComponentInfo(comp)"
      >
        <span matPrefix>More info</span>
        <mat-icon matSuffix>arrow_forward</mat-icon>
      </button>
    </td>
  </ng-container>

  <ng-container matColumnDef="optionsMenu">
    <th mat-header-cell *matHeaderCellDef></th>
    <td mat-cell *matCellDef="let comp">
      <button
        class="simplut-comp-table-menu-btn"
        color="primary"
        mat-icon-button
        aria-label="Icon button with a horizontal three dot icon"
        matMenuTrigger
        #moreHorizMenuTrigger="matMenuTrigger"
        [matMenuTriggerFor]="moreHorizMenu"
        [matMenuTriggerData]="{ comp }"
        [disabled]="isTemplatePreview"
      >
        <mat-icon>more_horiz</mat-icon>
      </button>
    </td>
  </ng-container>

  <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
  <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
</table>

<mat-menu #moreHorizMenu="matMenu">
  <ng-template matMenuContent let-comp="comp">
    @if (!isDataSpaceView) {
      <button
        class="simplut-config-comp-btn"
        disableRipple
        mat-menu-item
        (click)="openConfigureComponentDialog(comp)"
      >
        <mat-icon class="text-primary material-icons-outlined">
          settings
        </mat-icon>
        <span class="text-primary">Configure component</span>
      </button>
      <button
        class="simplut-change-comp-btn"
        disableRipple
        mat-menu-item
        (click)="openChangeComponentDialog(comp)"
      >
        <mat-icon class="text-primary material-icons-outlined">
          change_circle
        </mat-icon>
        <span class="text-primary">Change component</span>
      </button>
    } @else {
      <button
        class="simplut-console-comp-btn"
        disableRipple
        mat-menu-item
        (click)="openComponentConsole()"
      >
        <mat-icon class="text-primary material-icons-outlined">
          terminal
        </mat-icon>
        <span class="text-primary">Access console / logs</span>
      </button>
      <button
        class="simplut-ui-comp-btn"
        [disabled]="comp.type !== 'FE_COMPONENT'"
        disableRipple
        mat-menu-item
      >
        <mat-icon class="text-primary material-icons-outlined">
          monitor
        </mat-icon>
        <span class="text-primary">
          <a
            class="access-ui-link text-primary"
            [href]="simplUrl"
            target="_blank"
            rel="noopener noreferrer"
          >
            Access component UI
          </a>
        </span>
      </button>
    }
  </ng-template>
</mat-menu>
